//@author: antokhio
//@help: template for compute shaders
//@tags: CS, template
//@credits: 

//StructuredBuffer<float4> color <bool color=true;>;

Texture2D tex0;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_POINT;AddressU=CLAMP;AddressV=CLAMP;};

RWStructuredBuffer<uint> Output : BACKBUFFER;

float2 R;


[numthreads(8, 8, 1)]
void CS( uint3 tid : SV_DispatchThreadID )
{
	uint idx = tid.x + tid.y * R.x;
	
	float2 uv = float2 ( tid.x / R.x , tid.y / R.y);
	
	float4 col = tex0.SampleLevel(s0, uv, 0);
	
	uint luma = (col.x + col.y + col.z) / 3  *  (429496729);
	
	
	InterlockedAdd(Output[0], luma);
}

[numthreads(8, 8, 1)]
void CS_Clear( uint3 tid : SV_DispatchThreadID )
{
	Output[tid.x] = 0;
}

technique11 Template
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}

technique11 ClearCounter
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS_Clear() ) );
	}
}





